/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.ParamAcumulaMasivo;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.ParamAcumulaMasivoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderSendaAmigoParamAcumulaMasivo;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Spinner;

/**
 *
 * @author Rafius //ParamAcumulaMasivo
 */
@Controller("busquedaParamAcumulaMasivoController")
@Scope("prototype")
public class BusquedaParamAcumulaMasivoController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<ParamAcumulaMasivo> plwParamAcumulaMasivo;
    @Autowired
    private ParamAcumulaMasivoService paramAcumulaMasivoService;
    @Autowired
    private EmpresaService empresaService;
    private List<Empresa> lsEmpresa;
    private List<ParamAcumulaMasivo> lsParamAcumulaMasivo;
    private Combobox cmbEmpresa;
    private Spinner max;
    private Spinner min;
    private Datebox fecInicio;
    private Datebox fecFinal;
    private MyListbox paramAcumulaMasivoList;
    private Paging pagingParamAcumulaMasivo;

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        lsEmpresa =  UsuarioLogado.getUsuarioLogado().getEmpresa();

        super.doAfterCompose(comp);

        paramAcumulaMasivoList.setItemRenderer(new RenderSendaAmigoParamAcumulaMasivo());
        paramAcumulaMasivoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                ParamAcumulaMasivo pa = (ParamAcumulaMasivo) paramAcumulaMasivoList.getSelected();
                verParamAcumulaMasivo(pa);
            }
        });

        lsParamAcumulaMasivo = new ArrayList<ParamAcumulaMasivo>();

        refreshLista();
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        Comboitem cbiEmpresa = cmbEmpresa.getSelectedItem();
        Empresa empresa = null;
        if (cbiEmpresa != null) {
            empresa = (Empresa) cbiEmpresa.getValue();
        }

        lsParamAcumulaMasivo.clear();
        lsParamAcumulaMasivo.addAll(
                paramAcumulaMasivoService.buscar(empresa, min.getValue(),
                max.getValue(), fecInicio.getValue(), fecFinal.getValue()));
        paramAcumulaMasivoList.setData(lsParamAcumulaMasivo);

        if (paramAcumulaMasivoList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaParamAcumulacionMasivoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verParamAcumulaMasivo(new ParamAcumulaMasivo());
    }

    private void verParamAcumulaMasivo(ParamAcumulaMasivo pa) {
        if (pa == null) {
            return;
        }

        Map args = new HashMap();
        args.put("paramAcumulaMasivo", pa);
        args.put("paramAcumulaMasivoList", paramAcumulaMasivoList);

        openWindow("/gui/senda_amigo/editarParamAcumulaMasivo.zul",
                Labels.getLabel("editarParamAcumulaMasivoController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<ParamAcumulaMasivo> tarifaBusqueda =
                new HibernateSearchObject<ParamAcumulaMasivo>(ParamAcumulaMasivo.class, pagingParamAcumulaMasivo.getPageSize());
        tarifaBusqueda.addFilterEqual("activo", Boolean.TRUE);
        
        tarifaBusqueda.addFilterIn("empresa", lsEmpresa);
        tarifaBusqueda.addSortAsc("empresa");
        
       
			
		

        plwParamAcumulaMasivo.init(tarifaBusqueda, paramAcumulaMasivoList, pagingParamAcumulaMasivo);


    }

    public Paging getPagingParamAcumulaMasivo() {
        return pagingParamAcumulaMasivo;
    }

    public void setPagingParamAcumulaMasivo(Paging pagingParamAcumulaMasivo) {
        this.pagingParamAcumulaMasivo = pagingParamAcumulaMasivo;
    }

    public Combobox getCmbPunto() {
        return cmbEmpresa;
    }

    public void setCmbPunto(Combobox cmbPunto) {
        this.cmbEmpresa = cmbPunto;
    }

    public List<ParamAcumulaMasivo> getLsParamAcumulaMasivo() {
        return lsParamAcumulaMasivo;
    }

    public void setLsParamAcumulaMasivo(List<ParamAcumulaMasivo> lsParamAcumulaMasivo) {
        this.lsParamAcumulaMasivo = lsParamAcumulaMasivo;
    }

    public MyListbox getParamAcumulaMasivoList() {
        return paramAcumulaMasivoList;
    }

    public void setParamAcumulaMasivoList(MyListbox paramAcumulaMasivoList) {
        this.paramAcumulaMasivoList = paramAcumulaMasivoList;
    }

    public ParamAcumulaMasivoService getParamAcumulaMasivoService() {
        return paramAcumulaMasivoService;
    }

    public void setParamAcumulaMasivoService(ParamAcumulaMasivoService paramAcumulaMasivoService) {
        this.paramAcumulaMasivoService = paramAcumulaMasivoService;
    }

    public PagedListWrapper<ParamAcumulaMasivo> getPlwParamAcumulaMasivo() {
        return plwParamAcumulaMasivo;
    }

    public void setPlwParamAcumulaMasivo(PagedListWrapper<ParamAcumulaMasivo> plwParamAcumulaMasivo) {
        this.plwParamAcumulaMasivo = plwParamAcumulaMasivo;
    }

    public Combobox getCmbEmpresa() {
        return cmbEmpresa;
    }

    public void setCmbEmpresa(Combobox cmbEmpresa) {
        this.cmbEmpresa = cmbEmpresa;
    }

    public EmpresaService getEmpresaService() {
        return empresaService;
    }

    public void setEmpresaService(EmpresaService empresaService) {
        this.empresaService = empresaService;
    }

    public List<Empresa> getLsEmpresa() {
        return lsEmpresa;
    }

    public void setLsEmpresa(List<Empresa> lsEmpresa) {
        this.lsEmpresa = lsEmpresa;
    }

    public Spinner getMax() {
        return max;
    }

    public void setMax(Spinner max) {
        this.max = max;
    }

    public Spinner getMin() {
        return min;
    }

    public void setMin(Spinner min) {
        this.min = min;
    }

    public Datebox getFecFinal() {
        return fecFinal;
    }

    public void setFecFinal(Datebox fecFinal) {
        this.fecFinal = fecFinal;
    }

    public Datebox getFecInicio() {
        return fecInicio;
    }

    public void setFecInicio(Datebox fecInicio) {
        this.fecInicio = fecInicio;
    }
}
